//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "ServerWnd.h"
#include "HttpDownloadDlg.h"
#include "HTRichEditCtrl.h"
#include "ED2KLink.h"
#include "kademlia/kademlia/kademlia.h"
#include "kademlia/kademlia/prefs.h"
#include "kademlia/utils/MiscUtils.h"
#include "OtherFunctions.h"
#include "emuledlg.h"
#include "WebServer.h"
#include "CustomAutoComplete.h"
#include "Server.h"
#include "ServerList.h"
#include "Sockets.h"
#include "MuleStatusBarCtrl.h"
#include "HelpIDs.h"
#include "NetworkInfoDlg.h"
#include "Log.h"
#include "ServerFilter.h" // [ionix] Avi3k: ServerFilter
#include "ModVersion.h" // [ionix] - Mod Version

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

#define	SERVERMET_STRINGS_PROFILE	_T("AC_ServerMetURLs.dat")
#define SZ_DEBUG_LOG_TITLE			_T("Verbose")

// CServerWnd dialog

IMPLEMENT_DYNAMIC(CServerWnd, CDialog)
CServerWnd::CServerWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CServerWnd::IDD, pParent)
{
	servermsgbox = new CHTRichEditCtrl;
	logbox = new CHTRichEditCtrl;
	modlog = new CHTRichEditCtrl; // [ionix] ModLog
	debuglog = new CHTRichEditCtrl;
	m_pacServerMetURL=NULL;
	m_uLangID = MAKELANGID(LANG_ENGLISH,SUBLANG_DEFAULT);
	icon_srvlist = NULL;
	MEMSET(&m_cfDef, 0, sizeof m_cfDef);
	MEMSET(&m_cfBold, 0, sizeof m_cfBold);
	StatusSelector.m_bCloseable = false;
}

CServerWnd::~CServerWnd()
{
	if (icon_srvlist)
		VERIFY( DestroyIcon(icon_srvlist) );
	if (m_pacServerMetURL){
		m_pacServerMetURL->Unbind();
		m_pacServerMetURL->Release();
	}
	delete debuglog;
	delete logbox;
	delete modlog; // [ionix] ModLog
	delete servermsgbox;
}

BOOL CServerWnd::OnInitDialog()
{
	if (theApp.m_fontLog.m_hObject == NULL)
       {
		CFont* pFont = GetDlgItem(IDC_SSTATIC)->GetFont();
		LOGFONT lf;
		pFont->GetObject(sizeof lf, &lf);
		theApp.m_fontLog.CreateFontIndirect(&lf);
	}

	ReplaceRichEditCtrl(GetDlgItem(IDC_MYINFOLIST), this, GetDlgItem(IDC_SSTATIC)->GetFont());
	CResizableDialog::OnInitDialog();

	// using ES_NOHIDESEL is actually not needed, but it helps to get around a tricky window update problem!
#define	LOG_PANE_RICHEDIT_STYTES WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL | ES_MULTILINE | ES_READONLY | ES_NOHIDESEL
	CRect rect;

	GetDlgItem(IDC_SERVMSG)->GetWindowRect(rect);
	GetDlgItem(IDC_SERVMSG)->DestroyWindow();
	::MapWindowPoints(NULL, m_hWnd, (LPPOINT)&rect, 2);
	if (servermsgbox->Create(LOG_PANE_RICHEDIT_STYTES, rect, this, IDC_SERVMSG)){
		servermsgbox->SetProfileSkinKey(_T("ServerInfoLog"));
		servermsgbox->ModifyStyleEx(0, WS_EX_STATICEDGE, SWP_FRAMECHANGED);
		servermsgbox->SendMessage(EM_SETMARGINS, EC_LEFTMARGIN | EC_RIGHTMARGIN, MAKELONG(3, 3));
		servermsgbox->SetEventMask(servermsgbox->GetEventMask() | ENM_LINK);
		servermsgbox->SetFont(&theApp.m_fontHyperText);
		servermsgbox->ApplySkin();
		servermsgbox->SetTitle(GetResString(IDS_SV_SERVERINFO));

		servermsgbox->AppendText(CString(CString("eMule v")+theApp.m_strCurVersionLong + _T(" ") + GetLongVersion() + CString("\n"))); // Pawcio: Mod Version
		// [ionix] START - MORPH, New Version Check 
		m_strIonixNewVersion = GetResString(IDS_EMULEW) + _T(" ") + GetResString(IDS_EMULEW3) + _T(" ") + GetResString(IDS_IONIXCHECK);
        servermsgbox->AppendHyperLink(_T(""),_T(""),m_strIonixNewVersion,_T(""),false); 
        servermsgbox->AppendText(_T("\n"));
		// [ionix] END - MORPH, New Version Check 
		// MOD Note: Do not remove this part - Merkur
		m_strClickNewVersion = GetResString(IDS_EMULEW) + _T(" ") + GetResString(IDS_EMULEW3) + _T(" ") + GetResString(IDS_EMULEW2);
		servermsgbox->AppendHyperLink(_T(""),_T(""),m_strClickNewVersion,_T(""),false);
		// MOD Note: end
		servermsgbox->AppendText(_T("\n\n"));
	}

	GetDlgItem(IDC_LOGBOX)->GetWindowRect(rect);
	GetDlgItem(IDC_LOGBOX)->DestroyWindow();
	::MapWindowPoints(NULL, m_hWnd, (LPPOINT)&rect, 2);
	if (logbox->Create(LOG_PANE_RICHEDIT_STYTES, rect, this, IDC_LOGBOX)){
		logbox->SetProfileSkinKey(_T("Log"));
		logbox->ModifyStyleEx(0, WS_EX_STATICEDGE, SWP_FRAMECHANGED);
		logbox->SendMessage(EM_SETMARGINS, EC_LEFTMARGIN | EC_RIGHTMARGIN, MAKELONG(3, 3));
		if (theApp.m_fontLog.m_hObject)
			logbox->SetFont(&theApp.m_fontLog);
		logbox->ApplySkin();
		logbox->SetTitle(GetResString(IDS_SV_LOG));
		logbox->SetAutoURLDetect(FALSE);
	}

	// [ionix] ModLog
	GetDlgItem(IDC_MODLOG)->GetWindowRect(rect);
	GetDlgItem(IDC_MODLOG)->DestroyWindow();
	::MapWindowPoints(NULL, m_hWnd, (LPPOINT)&rect, 2);
	if (modlog->Create(LOG_PANE_RICHEDIT_STYTES, rect, this, IDC_MODLOG)){
		modlog->SetProfileSkinKey(_T("Log"));
		modlog->ModifyStyleEx(0, WS_EX_STATICEDGE, SWP_FRAMECHANGED);
		modlog->SendMessage(EM_SETMARGINS, EC_LEFTMARGIN | EC_RIGHTMARGIN, MAKELONG(3, 3));
		if (theApp.m_fontLog.m_hObject)
			modlog->SetFont(&theApp.m_fontLog);
		modlog->ApplySkin();
		modlog->SetTitle(_T("iONiX Log"));
		modlog->SetAutoURLDetect(FALSE);
	}
	// [ionix] ModLog

	GetDlgItem(IDC_DEBUG_LOG)->GetWindowRect(rect);
	GetDlgItem(IDC_DEBUG_LOG)->DestroyWindow();
	::MapWindowPoints(NULL, m_hWnd, (LPPOINT)&rect, 2);
	if (debuglog->Create(LOG_PANE_RICHEDIT_STYTES, rect, this, IDC_DEBUG_LOG)){
		debuglog->SetProfileSkinKey(_T("VerboseLog"));
		debuglog->ModifyStyleEx(0, WS_EX_STATICEDGE, SWP_FRAMECHANGED);
		debuglog->SendMessage(EM_SETMARGINS, EC_LEFTMARGIN | EC_RIGHTMARGIN, MAKELONG(3, 3));
		if (theApp.m_fontLog.m_hObject)
			debuglog->SetFont(&theApp.m_fontLog);
		debuglog->ApplySkin();
		debuglog->SetTitle(SZ_DEBUG_LOG_TITLE);
		debuglog->SetAutoURLDetect(FALSE);
	}

	SetAllIcons();
	Localize();

 // [ionix] VIEW SERVER //
	infoview = 0;
 // [ionix] VIEW SERVER //

	serverlistctrl.Init(theApp.serverlist);

	((CEdit*)GetDlgItem(IDC_SPORT))->SetLimitText(5);
	GetDlgItem(IDC_SPORT)->SetWindowText(_T("4661"));

	TCITEM newitem;
	CString name;
	name = GetResString(IDS_SV_SERVERINFO);
	newitem.mask = TCIF_TEXT|TCIF_IMAGE;
	newitem.pszText = const_cast<LPTSTR>((LPCTSTR)name);
	newitem.iImage = 1;
	VERIFY( StatusSelector.InsertItem(StatusSelector.GetItemCount(), &newitem) == PaneServerInfo );

	name = GetResString(IDS_SV_LOG);
	newitem.mask = TCIF_TEXT|TCIF_IMAGE;
	newitem.pszText = const_cast<LPTSTR>((LPCTSTR)name);
	newitem.iImage = 0;
	VERIFY( StatusSelector.InsertItem(StatusSelector.GetItemCount(), &newitem) == PaneLog );

	// [ionix] ModLog
	name = _T("iONiX Log");
	newitem.mask = TCIF_TEXT|TCIF_IMAGE;
	newitem.pszText = const_cast<LPTSTR>((LPCTSTR)name);
	newitem.cchTextMax = (int)name.GetLength()+1;
	newitem.iImage = 2;
	VERIFY( StatusSelector.InsertItem(StatusSelector.GetItemCount(),&newitem) == PaneModLog );
	// [ionix] ModLog

	name=SZ_DEBUG_LOG_TITLE;
	newitem.mask = TCIF_TEXT|TCIF_IMAGE;
	newitem.pszText = const_cast<LPTSTR>((LPCTSTR)name);
	newitem.iImage = 0;
	VERIFY( StatusSelector.InsertItem(StatusSelector.GetItemCount(), &newitem) == PaneVerboseLog );	// bobo modlog - removed by [Aireoreion]

// [ionix] VIEW SERVER //
	AddAnchor(IDC_SERVLIST,TOP_LEFT, CSize(100,50));
	AddAnchor(IDC_LOGBOX, CSize(0,50), BOTTOM_RIGHT);
	AddAnchor(IDC_MODLOG, CSize(0,50), BOTTOM_RIGHT); // bobo modlog
	AddAnchor(IDC_DEBUG_LOG, CSize(0,50), BOTTOM_RIGHT);
    //Update with url
	AddAnchor(serverlistctrl, TOP_LEFT, MIDDLE_RIGHT);
	AddAnchor(m_ctrlNewServerFrm, MIDDLE_RIGHT); // Frame
	AddAnchor(IDC_SSTATIC4, MIDDLE_RIGHT);
	AddAnchor(IDC_SSTATIC7, MIDDLE_RIGHT);
	AddAnchor(IDC_IPADDRESS, MIDDLE_RIGHT);
	AddAnchor(IDC_SSTATIC3, MIDDLE_RIGHT);
	AddAnchor(IDC_SNAME, MIDDLE_RIGHT);
	AddAnchor(IDC_ADDSERVER, MIDDLE_RIGHT);
	AddAnchor(IDC_SSTATIC5, MIDDLE_RIGHT);
	//info
	AddAnchor(m_ctrlMyInfoFrm, MIDDLE_RIGHT, BOTTOM_RIGHT); // Frame
	AddAnchor(m_MyInfo, MIDDLE_RIGHT, BOTTOM_RIGHT);
    //Update server.met
	AddAnchor(IDC_SPORT, CSize(100,50));
	AddAnchor(m_ctrlUpdateServerFrm, CSize(100,50)); // Frame
	AddAnchor(IDC_SERVERMETURL, CSize(100,50));
	AddAnchor(IDC_UPDATESERVERMETFROMURL, CSize(100,50));
	AddAnchor(StatusSelector, CSize(0,50), BOTTOM_RIGHT);
	AddAnchor(IDC_LOGRESET, MIDDLE_RIGHT); // avoid resizing GUI glitches with the tab control by adding this control as the last one (Z-order)
	// [ionix] Avi3k: ServerFilter 
	AddAnchor(IDC_SRVFILTER_BTN, TOP_LEFT); 
	// [ionix] Avi3k: ServerFilter
	//>>> Fenderman - Spooky Mode [eWombat] 
	#ifdef SPOOKY 
	AddAnchor(IDC_SPOOKYCONNECT, TOP_LEFT); 
	#endif 
	//<<< Fenderman - Spooky Mode [eWombat] 
	AddAnchor(IDC_ED2KCONNECT,CSize(100,50)); // avoid resizing GUI glitches with the tab control by adding this control as the last one (Z-order)
	AddAnchor(IDC_DD,CSize(100,50));// [iONiX] VIEW SERVER //
	AddAnchor(IDC_HIDEINFO,CSize(100,50));// [iONiX] VIEW SERVER //
// [ionix] VIEW SERVER //

	if (servermsgbox->m_hWnd)
	AddAnchor(*servermsgbox, MIDDLE_LEFT, BOTTOM_RIGHT);
	debug = true;
	ToggleDebugWindow();

// [iONiX] VIEW SERVER //
	GetDlgItem(IDC_MYINFOLIST)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_MYINFO)->ShowWindow(SW_SHOW); // FRAME
    //Update server.met
	GetDlgItem(IDC_DD)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC6)->ShowWindow(SW_HIDE); // FRAME
	GetDlgItem(IDC_SERVERMETURL)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_UPDATESERVERMETFROMURL)->ShowWindow(SW_HIDE);
	//Update with url
	GetDlgItem(IDC_SSTATIC4)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_IPADDRESS)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC7)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SPORT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC3)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SNAME)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC5)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC )->ShowWindow(SW_HIDE); // FRAME
	GetDlgItem(IDC_ADDSERVER)->ShowWindow(SW_HIDE);
// [iONiX] VIEW SERVER //

	debuglog->ShowWindow(SW_HIDE);
	logbox->ShowWindow(SW_HIDE);
	modlog->ShowWindow(SW_HIDE); // [ionix] ModLog
		servermsgbox->ShowWindow(SW_SHOW);

	// optional: restore last used log pane
	if (thePrefs.GetRestoreLastLogPane())
	{
		if (thePrefs.GetLastLogPaneID() >= 0 && thePrefs.GetLastLogPaneID() < StatusSelector.GetItemCount())
		{
			int iCurSel = StatusSelector.GetCurSel();
			StatusSelector.SetCurSel(thePrefs.GetLastLogPaneID());
			if (thePrefs.GetLastLogPaneID() == StatusSelector.GetCurSel())
				UpdateLogTabSelection();
			else
				StatusSelector.SetCurSel(iCurSel);
		}
	}

	m_MyInfo.SendMessage(EM_SETMARGINS, EC_LEFTMARGIN | EC_RIGHTMARGIN, MAKELONG(3, 3));
	m_MyInfo.SetAutoURLDetect();
	m_MyInfo.SetEventMask(m_MyInfo.GetEventMask() | ENM_LINK);

	PARAFORMAT pf = {0};
	pf.cbSize = sizeof pf;
	if (m_MyInfo.GetParaFormat(pf)){
		pf.dwMask |= PFM_TABSTOPS;
		pf.cTabCount = 4;
		pf.rgxTabs[0] = 900;
		pf.rgxTabs[1] = 1000;
		pf.rgxTabs[2] = 1100;
		pf.rgxTabs[3] = 1200;
		m_MyInfo.SetParaFormat(pf);
	}

	m_cfDef.cbSize = sizeof m_cfDef;
	if (m_MyInfo.GetSelectionCharFormat(m_cfDef)){
		m_cfBold = m_cfDef;
		m_cfBold.dwMask |= CFM_BOLD;
		m_cfBold.dwEffects |= CFE_BOLD;
	}

	if (thePrefs.GetUseAutocompletion()){
		m_pacServerMetURL = new CCustomAutoComplete();
		m_pacServerMetURL->AddRef();
		if (m_pacServerMetURL->Bind(::GetDlgItem(m_hWnd, IDC_SERVERMETURL), ACO_UPDOWNKEYDROPSLIST | ACO_AUTOSUGGEST | ACO_FILTERPREFIXES ))
			m_pacServerMetURL->LoadList(CString(thePrefs.GetConfigDir()) +  _T("\\") SERVERMET_STRINGS_PROFILE);
		if (theApp.emuledlg->m_fontMarlett.m_hObject){
			GetDlgItem(IDC_DD)->SetFont(&theApp.emuledlg->m_fontMarlett);
			GetDlgItem(IDC_DD)->SetWindowText(_T("6")); // show a down-arrow
		}
	}
	else
		GetDlgItem(IDC_DD)->ShowWindow(SW_HIDE);

	InitWindowStyles(this);

	return true;
}

void CServerWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SERVLIST, serverlistctrl);
	DDX_Control(pDX, IDC_SSTATIC, m_ctrlNewServerFrm);
	DDX_Control(pDX, IDC_SSTATIC6, m_ctrlUpdateServerFrm);
	DDX_Control(pDX, IDC_MYINFO, m_ctrlMyInfoFrm);
	DDX_Control(pDX, IDC_TAB3, StatusSelector);
	// [ionix] Avi3k: ServerFilter 
    DDX_Control(pDX, IDC_SRVFILTER_BTN, m_cServerfilter); 
	// [ionix] Avi3k: ServerFilter
	//>>> Fenderman - Spooky Mode [eWombat] 
	#ifdef SPOOKY 
    DDX_Control(pDX, IDC_SPOOKYCONNECT, m_cSpookyConnect); 
	#endif 
	//<<< Fenderman - Spooky Mode [eWombat] 
	DDX_Control(pDX, IDC_MYINFOLIST, m_MyInfo);
}

bool CServerWnd::UpdateServerMetFromURL(CString strURL)
{
	if (strURL.IsEmpty() || (strURL.Find(_T("://")) == -1))	// not a valid URL
	{
		LogError(LOG_STATUSBAR, GetResString(IDS_INVALIDURL) );
		return false;
	}

	// add entered URL to LRU list even if it's not yet known whether we can download from this URL (it's just more convenient this way)
	if (m_pacServerMetURL && m_pacServerMetURL->IsBound())
		m_pacServerMetURL->AddItem(strURL, 0);

	CString strTempFilename;
	strTempFilename.Format(_T("%stemp-%d-server.met"), thePrefs.GetConfigDir(), ::GetTickCount());

	// try to download server.met
	CHttpDownloadDlg dlgDownload;
	dlgDownload.m_sURLToDownload = strURL;
	dlgDownload.m_sFileToDownloadInto = strTempFilename;
	if (dlgDownload.DoModal() != IDOK)
	{
		LogError(LOG_STATUSBAR, GetResString(IDS_ERR_FAILEDDOWNLOADMET), strURL);
		return false;
	}

	// add content of server.met to serverlist
	serverlistctrl.Hide();
	serverlistctrl.AddServermetToList(strTempFilename);
	serverlistctrl.Visable();
	_tremove(strTempFilename);
	return true;
}

void CServerWnd::OnSysColorChange()
{
	CResizableDialog::OnSysColorChange();
	SetAllIcons();
}

void CServerWnd::SetAllIcons()
{
	m_ctrlNewServerFrm.SetIcon(_T("AddServer"));
	m_ctrlUpdateServerFrm.SetIcon(_T("ServerUpdateMET"));
	m_ctrlMyInfoFrm.SetIcon(_T("Info"));

	CImageList iml;
	iml.Create(16,16,theApp.m_iDfltImageListColorFlags|ILC_MASK,0,1);
	iml.Add(CTempIconLoader(_T("Log")));
	iml.Add(CTempIconLoader(_T("ServerInfo")));
	iml.Add(CTempIconLoader(_T("IONIX"))); // [ionix] ModLog
	StatusSelector.SetImageList(&iml);
	m_imlLogPanes.DeleteImageList();
	m_imlLogPanes.Attach(iml.Detach());
	m_cServerfilter.SetIcon(_T("serverfilter"), NULL); // [ionix] Avi3k: ServerFilter 

	if (icon_srvlist)
		VERIFY( DestroyIcon(icon_srvlist) );
	icon_srvlist = theApp.LoadIcon(_T("ServerList"), 16, 16);
	((CStatic*)GetDlgItem(IDC_SERVLST_ICO))->SetIcon(icon_srvlist);
}

void CServerWnd::Localize()
{
	serverlistctrl.Localize();

	if (thePrefs.GetLanguageID() != m_uLangID){
		m_uLangID = thePrefs.GetLanguageID();
		// [ionix] Avi3k: ServerFilter 		
		m_cServerfilter.SetWindowText(_T("Adv. Serverfilter")); 
		// [ionix] Avi3k: ServerFilter 
		//>>> Fenderman - Spooky Mode [eWombat]		
		#ifdef SPOOKY 
		m_cSpookyConnect.SetWindowText(_T("Spooky Mode")); 
		#endif 
		//<<< Fenderman - Spooky Mode [eWombat]
	    GetDlgItem(IDC_SERVLIST_TEXT)->SetWindowText(GetResString(IDS_SV_SERVERLIST));
	    m_ctrlNewServerFrm.SetWindowText(GetResString(IDS_SV_NEWSERVER));
	    GetDlgItem(IDC_SSTATIC4)->SetWindowText(GetResString(IDS_SV_ADDRESS));
	    GetDlgItem(IDC_SSTATIC7)->SetWindowText(GetResString(IDS_SV_PORT));
	    GetDlgItem(IDC_SSTATIC3)->SetWindowText(GetResString(IDS_SW_NAME));
	    GetDlgItem(IDC_ADDSERVER)->SetWindowText(GetResString(IDS_SV_ADD));
	    m_ctrlUpdateServerFrm.SetWindowText(GetResString(IDS_SV_MET));
	    GetDlgItem(IDC_UPDATESERVERMETFROMURL)->SetWindowText(GetResString(IDS_SV_UPDATE));
	    GetDlgItem(IDC_LOGRESET)->SetWindowText(GetResString(IDS_PW_RESET));
	    m_ctrlMyInfoFrm.SetWindowText(GetResString(IDS_MYINFO));
    
// [ionix] VIEW SERVER //
	    GetDlgItem(IDC_HIDEINFO)->SetWindowText(_T("&Hide Info")); // or (GetResString(IDS_HIDEINFO_SHOW)  // [iONiX] VIEW SERVER //  
// [ionix] VIEW SERVER //
    
	    TCITEM item;
	    CString name;
	    name = GetResString(IDS_SV_SERVERINFO);
	    item.mask = TCIF_TEXT;
		item.pszText = const_cast<LPTSTR>((LPCTSTR)name);
		StatusSelector.SetItem(PaneServerInfo, &item);

	    name = GetResString(IDS_SV_LOG);
	    item.mask = TCIF_TEXT;
		item.pszText = const_cast<LPTSTR>((LPCTSTR)name);
		StatusSelector.SetItem(PaneLog, &item);

		// [ionix] ModLog
		name = _T("iONiX Log");
	    item.mask = TCIF_TEXT;
		item.pszText = const_cast<LPTSTR>((LPCTSTR)name);
		StatusSelector.SetItem(PaneModLog, &item);
		// [ionix] ModLog
		
	    name = SZ_DEBUG_LOG_TITLE;
	    item.mask = TCIF_TEXT;
		item.pszText = const_cast<LPTSTR>((LPCTSTR)name);
		StatusSelector.SetItem(PaneVerboseLog, &item);
	}

	UpdateLogTabSelection();
	UpdateControlsState();
}

BEGIN_MESSAGE_MAP(CServerWnd, CResizableDialog)
	ON_BN_CLICKED(IDC_ADDSERVER, OnBnClickedAddserver)
	ON_BN_CLICKED(IDC_UPDATESERVERMETFROMURL, OnBnClickedUpdateservermetfromurl)
	ON_BN_CLICKED(IDC_LOGRESET, OnBnClickedResetLog)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB3, OnTcnSelchangeTab3)
	ON_NOTIFY(EN_LINK, IDC_SERVMSG, OnEnLinkServerBox)
	ON_BN_CLICKED(IDC_ED2KCONNECT, OnBnConnect)
	//>>> Fenderman - Spooky Mode [eWombat] 
	#ifdef SPOOKY 
    ON_BN_CLICKED(IDC_SPOOKYCONNECT, OnSpookyconnect) 
	#endif 
	//<<< Fenderman - Spooky Mode [eWombat] 
	ON_WM_SYSCOLORCHANGE()
	ON_BN_CLICKED(IDC_DD,OnDDClicked)
	ON_WM_HELPINFO()
	ON_EN_CHANGE(IDC_IPADDRESS, OnSvrTextChange)
	ON_EN_CHANGE(IDC_SPORT, OnSvrTextChange)
	ON_EN_CHANGE(IDC_SNAME, OnSvrTextChange)
	ON_EN_CHANGE(IDC_SERVERMETURL, OnSvrTextChange)
	ON_STN_DBLCLK(IDC_SERVLST_ICO, OnStnDblclickServlstIco)

// [ionix] VIEW SERVER //
	ON_BN_CLICKED(IDC_HIDEINFO, OnBnClickedChangeInfoView) // [ionix] VIEW SERVER //
// [ionix] VIEW SERVER //
	ON_BN_CLICKED(IDC_SRVFILTER_BTN, OnBnClickedServerFilterDlg) // [ionix] Avi3k: ServerFilter
END_MESSAGE_MAP()


// CServerWnd message handlers

void CServerWnd::OnBnClickedAddserver()
{
	CString serveraddr;
	if (!GetDlgItem(IDC_IPADDRESS)->GetWindowTextLength()){
		AfxMessageBox(GetResString(IDS_SRV_ADDR));
		return;
	}
	else
		GetDlgItem(IDC_IPADDRESS)->GetWindowText(serveraddr);

	UINT uPort = 0;
	if (_tcsncmp(serveraddr, _T("ed2k://"), 7) == 0){
		CED2KLink* pLink = NULL;
		try{
			pLink = CED2KLink::CreateLinkFromUrl(serveraddr);
			serveraddr.Empty();
			if (pLink && pLink->GetKind() == CED2KLink::kServer){
				CED2KServerLink* pServerLink = pLink->GetServerLink();
				if (pServerLink){
					uint32 nServerIP = pServerLink->GetIP();
					uPort = pServerLink->GetPort();
					serveraddr = ipstr(nServerIP);
					SetDlgItemText(IDC_IPADDRESS, serveraddr);
					SetDlgItemInt(IDC_SPORT, uPort, FALSE);
				}
			}
		}
		catch(CString strError){
			AfxMessageBox(strError);
			serveraddr.Empty();
		}
		delete pLink;
	}
	else{
		if (!GetDlgItem(IDC_SPORT)->GetWindowTextLength()){
			AfxMessageBox(GetResString(IDS_SRV_PORT));
			return;
		}

		BOOL bTranslated = FALSE;
		uPort = GetDlgItemInt(IDC_SPORT, &bTranslated, FALSE);
		if (!bTranslated){
			AfxMessageBox(GetResString(IDS_SRV_PORT));
			return;
		}
	}

	if (serveraddr.IsEmpty() || uPort == 0){
		AfxMessageBox(GetResString(IDS_SRV_ADDR));
		return;
	}

	CString strServerName;
	GetDlgItem(IDC_SNAME)->GetWindowText(strServerName);

	AddServer(uPort, serveraddr, strServerName);
}

void CServerWnd::PasteServerFromClipboard()
{
	CString strServer = theApp.CopyTextFromClipboard();
	strServer.Trim();
	if (strServer.IsEmpty())
		return;

	int nPos = 0;
	CString strTok = strServer.Tokenize(_T(" \t\r\n"), nPos);
	while (!strTok.IsEmpty())
	{
		uint32 nIP = 0;
		uint16 nPort = 0;
		CED2KLink* pLink = NULL;
		try{
			pLink = CED2KLink::CreateLinkFromUrl(strTok);
			if (pLink && pLink->GetKind() == CED2KLink::kServer){
				CED2KServerLink* pServerLink = pLink->GetServerLink();
				if (pServerLink){
					nIP = pServerLink->GetIP();
					nPort = pServerLink->GetPort();
				}
			}
		}
		catch(CString strError){
			AfxMessageBox(strError);
		}
		delete pLink;

		if (nIP == 0 || nPort == 0)
			break;

		(void)AddServer(nPort, ipstr(nIP), _T(""), false);
		strTok = strServer.Tokenize(_T(" \t\r\n"), nPos);
	}
}

bool CServerWnd::AddServer(uint16 nPort, CString strIP, CString strName, bool bShowErrorMB)
{
	CServer* toadd = new CServer(nPort, strIP);

	// Barry - Default all manually added servers to high priority
	if (thePrefs.GetManualHighPrio())
		toadd->SetPreference(SRV_PR_HIGH);

	if (strName.IsEmpty())
		strName = strIP;
	toadd->SetListName(strName);

	if (!serverlistctrl.AddServer(toadd, true))
	{
		CServer* update = theApp.serverlist->GetServerByAddress(toadd->GetAddress(), toadd->GetPort());
		if (update)
		{
			static const TCHAR _aszServerPrefix[] = _T("Server");
			if (_tcsnicmp(toadd->GetListName(), _aszServerPrefix, ARRSIZE(_aszServerPrefix)-1) != 0)
			{
				update->SetListName(toadd->GetListName());
				serverlistctrl.RefreshServer(update);
			}
		}
		else
		{
			if (bShowErrorMB)
				AfxMessageBox(GetResString(IDS_SRV_NOTADDED));
		}
		delete toadd;
		return false;
	}
	else
	{
		AddLogLine(true, GetResString(IDS_SERVERADDED), toadd->GetListName());
		return true;
	}
}

void CServerWnd::OnBnClickedUpdateservermetfromurl()
{
	// step1 - get url
	CString strURL;
	bool bDownloaded=false;
	GetDlgItem(IDC_SERVERMETURL)->GetWindowText(strURL);
	
	if (strURL==_T("")){
		if (thePrefs.adresses_list.IsEmpty()){
			AddLogLine(true, GetResString(IDS_SRV_NOURLAV) );
			return;
		}
		else
		{
			POSITION Pos = thePrefs.adresses_list.GetHeadPosition(); 
			while ((!bDownloaded) && (Pos != NULL)){
				strURL = thePrefs.adresses_list.GetNext(Pos).GetBuffer(); 
				bDownloaded=UpdateServerMetFromURL(strURL);
			}
		}
	}
	else
		UpdateServerMetFromURL(strURL);
}

void CServerWnd::OnBnClickedResetLog()
{
	int cur_sel = StatusSelector.GetCurSel();
	if (cur_sel == -1)
		return;
	if (cur_sel == PaneVerboseLog)
	{
		theApp.emuledlg->ResetDebugLog();
		theApp.emuledlg->statusbar->SetText(_T(""), SBarLog, 0);
	}
	if (cur_sel == PaneModLog) { // [ionix] ModLog
		theApp.emuledlg->ResetModLog();
	}
	if (cur_sel == PaneLog)
	{
		theApp.emuledlg->ResetLog();
		theApp.emuledlg->statusbar->SetText(_T(""), SBarLog, 0);
	}
	if (cur_sel == PaneServerInfo)
	{
		servermsgbox->Reset();
		// the statusbar does not contain any server log related messages, so it's not cleared.
	}
}

void CServerWnd::OnTcnSelchangeTab3(NMHDR *pNMHDR, LRESULT *pResult)
{
	UpdateLogTabSelection();
	*pResult = 0;
}

void CServerWnd::UpdateLogTabSelection()
{
	int cur_sel = StatusSelector.GetCurSel();
	if (cur_sel == -1)
		return;
	if (cur_sel == PaneVerboseLog)
	{
		servermsgbox->ShowWindow(SW_HIDE);
		logbox->ShowWindow(SW_HIDE);
		modlog->ShowWindow(SW_HIDE); // [ionix] ModLog
		debuglog->ShowWindow(SW_SHOW);
		debuglog->Invalidate();
		StatusSelector.HighlightItem(cur_sel, FALSE);
	}
	if (cur_sel == PaneModLog) { // [ionix] ModLog
		servermsgbox->ShowWindow(SW_HIDE);
		logbox->ShowWindow(SW_HIDE);
		debuglog->ShowWindow(SW_HIDE);
		modlog->ShowWindow(SW_SHOW);
		modlog->Invalidate();
		StatusSelector.HighlightItem(cur_sel, FALSE);
	}
	if (cur_sel == PaneLog)
	{
		debuglog->ShowWindow(SW_HIDE);
		servermsgbox->ShowWindow(SW_HIDE);
		modlog->ShowWindow(SW_HIDE); // [ionix] ModLog
		logbox->ShowWindow(SW_SHOW);
		logbox->Invalidate();
		StatusSelector.HighlightItem(cur_sel, FALSE);
	}
	if (cur_sel == PaneServerInfo)
	{
		debuglog->ShowWindow(SW_HIDE);
		modlog->ShowWindow(SW_HIDE); // [ionix] ModLog
		logbox->ShowWindow(SW_HIDE);
		servermsgbox->ShowWindow(SW_SHOW);
		servermsgbox->Invalidate();
		StatusSelector.HighlightItem(cur_sel, FALSE);
	}
}

void CServerWnd::ToggleDebugWindow()
{
	int cur_sel = StatusSelector.GetCurSel();
	if (thePrefs.GetVerbose() && !debug)
	{
		TCITEM newitem;
		CString name;
		name = SZ_DEBUG_LOG_TITLE;
		newitem.mask = TCIF_TEXT|TCIF_IMAGE;
		newitem.pszText = const_cast<LPTSTR>((LPCTSTR)name);
		newitem.iImage = 0;
		StatusSelector.InsertItem(StatusSelector.GetItemCount(),&newitem);
		debug = true;
	}
	else if (!thePrefs.GetVerbose() && debug)
	{
		if (cur_sel == PaneVerboseLog)
		{
			StatusSelector.SetCurSel(PaneLog);
			StatusSelector.SetFocus();
		}
		debuglog->ShowWindow(SW_HIDE);
		servermsgbox->ShowWindow(SW_HIDE);
		logbox->ShowWindow(SW_SHOW);
		StatusSelector.DeleteItem(PaneVerboseLog);
		debug = false;
	}
}

void CServerWnd::UpdateMyInfo()
{
	m_MyInfo.SetRedraw(FALSE);
	m_MyInfo.SetWindowText(_T(""));
	CreateNetworkInfo(m_MyInfo, m_cfDef, m_cfBold);

//[ionix] - START - Display Userhash in Status Window //
	CString buffer;
	m_MyInfo << _T("\r\n");
	buffer.Format(_T("%s"),(LPCTSTR)(md4str((uchar*)thePrefs.GetUserHash())));
	m_MyInfo << GetResString(IDS_CD_UHASH) << _T("\t") << buffer.Left (16) << _T("-");
	m_MyInfo << _T("\r\n\t") << buffer.Mid (16,255);
//[ionix] - END - Display Userhash in Status Window //

	m_MyInfo.SetRedraw(TRUE);
	m_MyInfo.Invalidate();
}

BOOL CServerWnd::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN){

		if (pMsg->wParam == VK_ESCAPE)
			return FALSE;

		if( m_pacServerMetURL && m_pacServerMetURL->IsBound() && ((pMsg->wParam == VK_DELETE) && (pMsg->hwnd == GetDlgItem(IDC_SERVERMETURL)->m_hWnd) && (GetAsyncKeyState(VK_MENU)<0 || GetAsyncKeyState(VK_CONTROL)<0)) )
			m_pacServerMetURL->Clear();

		if (pMsg->wParam == VK_RETURN){
			if (   pMsg->hwnd == GetDlgItem(IDC_IPADDRESS)->m_hWnd
				|| pMsg->hwnd == GetDlgItem(IDC_SPORT)->m_hWnd
				|| pMsg->hwnd == GetDlgItem(IDC_SNAME)->m_hWnd){

				OnBnClickedAddserver();
				return TRUE;
			}
			else if (pMsg->hwnd == GetDlgItem(IDC_SERVERMETURL)->m_hWnd){
				if (m_pacServerMetURL && m_pacServerMetURL->IsBound() ){
					CString strText;
					GetDlgItem(IDC_SERVERMETURL)->GetWindowText(strText);
					if (!strText.IsEmpty()){
						GetDlgItem(IDC_SERVERMETURL)->SetWindowText(_T("")); // this seems to be the only chance to let the dropdown list to disapear
						GetDlgItem(IDC_SERVERMETURL)->SetWindowText(strText);
						((CEdit*)GetDlgItem(IDC_SERVERMETURL))->SetSel(strText.GetLength(), strText.GetLength());
					}
				}
				OnBnClickedUpdateservermetfromurl();
				return TRUE;
			}
		}
	}
   
	return CResizableDialog::PreTranslateMessage(pMsg);
}

BOOL CServerWnd::SaveServerMetStrings()
{
	if (m_pacServerMetURL== NULL)
		return FALSE;
	return m_pacServerMetURL->SaveList(CString(thePrefs.GetConfigDir()) + _T("\\") SERVERMET_STRINGS_PROFILE);
}

void CServerWnd::ShowNetworkInfo()
{
	CNetworkInfoDlg dlg;
	dlg.DoModal();
}

void CServerWnd::OnEnLinkServerBox(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;
	ENLINK* pEnLink = reinterpret_cast<ENLINK *>(pNMHDR);
	if (pEnLink && pEnLink->msg == WM_LBUTTONDOWN)
	{
		CString strUrl;
		servermsgbox->GetTextRange(pEnLink->chrg.cpMin, pEnLink->chrg.cpMax, strUrl);
		if (strUrl == m_strClickNewVersion){
			// MOD Note: Do not remove this part - Merkur
			strUrl.Format(_T("/en/version_check.php?version=%i&language=%i"),theApp.m_uCurVersionCheck,thePrefs.GetLanguageID());
			strUrl = thePrefs.GetVersionCheckBaseURL()+strUrl;
			// MOD Note: end
		}
		// [ionix] START - MORPH, New Version Check 
        else if (strUrl == m_strIonixNewVersion) 
        strUrl = _T("http://kademlia-net.de/koobi4/index.php?categ=57&parent=3&p=downloads&area=1"); 
        // [ionix] END   - MORPH, New Version Check
		ShellExecute(NULL, NULL, strUrl, NULL, NULL, SW_SHOWDEFAULT);
		*pResult = 1;
	}
}
//>>> Fenderman - Spooky Mode [eWombat] 
/*
void CServerWnd::UpdateControlsState()
{
	CString strLabel;
	if (theApp.serverconnect->IsConnected())
		strLabel = GetResString(IDS_MAIN_BTN_DISCONNECT);
	else if (theApp.serverconnect->IsConnecting())
		strLabel = GetResString(IDS_MAIN_BTN_CANCEL);
	else
		strLabel = GetResString(IDS_MAIN_BTN_CONNECT);
	strLabel.Remove(_T('&'));
	GetDlgItem(IDC_ED2KCONNECT)->SetWindowText(strLabel);
*/
#ifdef SPOOKY 
void CServerWnd::UpdateControlsState(bool bSpookyOnly) 
{ 
    CString strLabel; 
        //int iconid; 
    if (!bSpookyOnly) 
    { 
    if (theApp.serverconnect->IsConnected()) 
        strLabel = GetResString(IDS_MAIN_BTN_DISCONNECT); 
    else if (theApp.serverconnect->IsConnecting()) 
        strLabel = GetResString(IDS_MAIN_BTN_CANCEL); 
    else 
        strLabel = GetResString(IDS_MAIN_BTN_CONNECT); 
    strLabel.Remove(_T('&')); 
    GetDlgItem(IDC_ED2KCONNECT)->SetWindowText(strLabel); 
} 
    //m_cSpookyConnect.EnableWindow(thePrefs.EnableSpookyMode()); 
	m_cSpookyConnect.EnableWindow(theApp.conchecker.SpookyAvailable() && theApp.GetConnectionState()!=CONSTATE_OFFLINE); 
	m_cSpookyConnect.SetIcon(theApp.serverconnect->IsSpooky()?_T("IDI_CANCEL"):_T("IDI_SPOOKY"), NULL); // WiZaRd
} 
#else 
void CServerWnd::UpdateControlsState()
{
	CString strLabel;
	if (theApp.serverconnect->IsConnected())
		strLabel = GetResString(IDS_MAIN_BTN_DISCONNECT);
	else if (theApp.serverconnect->IsConnecting())
		strLabel = GetResString(IDS_MAIN_BTN_CANCEL);
	else
		strLabel = GetResString(IDS_MAIN_BTN_CONNECT);
	strLabel.Remove(_T('&'));
	GetDlgItem(IDC_ED2KCONNECT)->SetWindowText(strLabel);
//<<< Fenderman - Spooky Mode [eWombat] 
// [ionix] // -Change view in server window
	infoview%=1;
    GetDlgItem(IDC_HIDEINFO)->SetWindowText(_T("&Hide Info")); // or (GetResString(IDS_HIDEINFO_HIDE)
	GetDlgItem(IDC_MYINFOLIST)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_MYINFO)->ShowWindow(SW_SHOW); // FRAME
    //Update server.met
	GetDlgItem(IDC_DD)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC6)->ShowWindow(SW_HIDE); // FRAME
	GetDlgItem(IDC_SERVERMETURL)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_UPDATESERVERMETFROMURL)->ShowWindow(SW_HIDE);
	//Update with url
	GetDlgItem(IDC_SSTATIC4)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_IPADDRESS)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC7)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SPORT)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC3)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SNAME)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC5)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_SSTATIC )->ShowWindow(SW_HIDE); // FRAME
	GetDlgItem(IDC_ADDSERVER)->ShowWindow(SW_HIDE);
// [ionix] // -Change view in server window
}
#endif 


void CServerWnd::OnBnConnect()
{
	if (theApp.serverconnect->IsConnected())
		theApp.serverconnect->Disconnect();
	else if (theApp.serverconnect->IsConnecting())
		theApp.serverconnect->StopConnectionTry();
	else
		theApp.serverconnect->ConnectToAnyServer();
}

// [iONiX] // -Change view in server window
void CServerWnd::OnBnClickedChangeInfoView()
{
	infoview++;
	infoview%=2;

	switch(infoview)
	{
	case 0://view server info
    		GetDlgItem(IDC_HIDEINFO)->SetWindowText(_T("&Hide Info")); // or (GetResString(IDS_HIDEINFO_HIDE)
		//info
		GetDlgItem(IDC_MYINFOLIST)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_MYINFO)->ShowWindow(SW_SHOW); // FRAME
     		//Update server.met
	        GetDlgItem(IDC_DD)->ShowWindow(SW_HIDE);
	     	GetDlgItem(IDC_SSTATIC6)->ShowWindow(SW_HIDE); // FRAME
	      	GetDlgItem(IDC_SERVERMETURL)->ShowWindow(SW_HIDE);
	      	GetDlgItem(IDC_UPDATESERVERMETFROMURL)->ShowWindow(SW_HIDE);
		//Update with url
	        GetDlgItem(IDC_SSTATIC4)->ShowWindow(SW_HIDE);
	      	GetDlgItem(IDC_IPADDRESS)->ShowWindow(SW_HIDE);
	      	GetDlgItem(IDC_SSTATIC7)->ShowWindow(SW_HIDE);
	      	GetDlgItem(IDC_SPORT)->ShowWindow(SW_HIDE);
	      	GetDlgItem(IDC_SSTATIC3)->ShowWindow(SW_HIDE);
	      	GetDlgItem(IDC_SNAME)->ShowWindow(SW_HIDE);
	      	GetDlgItem(IDC_SSTATIC5)->ShowWindow(SW_HIDE);
	      	GetDlgItem(IDC_SSTATIC )->ShowWindow(SW_HIDE); // FRAME
	      	GetDlgItem(IDC_ADDSERVER)->ShowWindow(SW_HIDE);

		break;

	case 1://dont view server info
		GetDlgItem(IDC_HIDEINFO)->SetWindowText(_T("&Show Info")); // or (GetResString(IDS_HIDEINFO_SHOW)
		//info
		GetDlgItem(IDC_MYINFOLIST)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_MYINFO)->ShowWindow(SW_HIDE); // FRAME
		//Update server.met
	        GetDlgItem(IDC_DD)->ShowWindow(SW_SHOW);
	     	GetDlgItem(IDC_SSTATIC6)->ShowWindow(SW_SHOW); // FRAME
	      	GetDlgItem(IDC_SERVERMETURL)->ShowWindow(SW_SHOW);
	      	GetDlgItem(IDC_UPDATESERVERMETFROMURL)->ShowWindow(SW_SHOW);
		//Update with url
	      	GetDlgItem(IDC_SSTATIC4)->ShowWindow(SW_SHOW);
	      	GetDlgItem(IDC_IPADDRESS)->ShowWindow(SW_SHOW);
	      	GetDlgItem(IDC_SSTATIC7)->ShowWindow(SW_SHOW);
	      	GetDlgItem(IDC_SPORT)->ShowWindow(SW_SHOW);
	      	GetDlgItem(IDC_SSTATIC3)->ShowWindow(SW_SHOW);
	      	GetDlgItem(IDC_SNAME)->ShowWindow(SW_SHOW);
	      	GetDlgItem(IDC_SSTATIC5)->ShowWindow(SW_SHOW);
	      	GetDlgItem(IDC_SSTATIC  )->ShowWindow(SW_SHOW); // FRAME
	      	GetDlgItem(IDC_ADDSERVER)->ShowWindow(SW_SHOW);

		break;
	}
}
// [iONiX] // -Change view in server window

void CServerWnd::SaveAllSettings()
{
	thePrefs.SetLastLogPaneID(StatusSelector.GetCurSel());
	serverlistctrl.SaveSettings(CPreferences::tableServer);
	SaveServerMetStrings();
}

void CServerWnd::OnDDClicked()
{
	CWnd* box = GetDlgItem(IDC_SERVERMETURL);
	box->SetFocus();
	box->SetWindowText(_T(""));
	box->SendMessage(WM_KEYDOWN, VK_DOWN, 0x00510001);
}

void CServerWnd::ResetHistory()
{
	if (m_pacServerMetURL == NULL)
		return;
	GetDlgItem(IDC_SERVERMETURL)->SendMessage(WM_KEYDOWN, VK_ESCAPE, 0x00510001);
	m_pacServerMetURL->Clear();
}

BOOL CServerWnd::OnHelpInfo(HELPINFO* pHelpInfo)
{
	theApp.ShowHelp(eMule_FAQ_Update_Server);
	return TRUE;
}

void CServerWnd::OnSvrTextChange()
{
	GetDlgItem(IDC_ADDSERVER)->EnableWindow(GetDlgItem(IDC_IPADDRESS)->GetWindowTextLength());
	GetDlgItem(IDC_UPDATESERVERMETFROMURL)->EnableWindow( GetDlgItem(IDC_SERVERMETURL)->GetWindowTextLength()>0 );
}

void CServerWnd::OnStnDblclickServlstIco()
{
	theApp.emuledlg->ShowPreferences(IDD_PPG_SERVER);
}

// [ionix] Avi3k: ServerFilter
void CServerWnd::OnBnClickedServerFilterDlg()
{
 CServerFilter dlg(theApp.serverlist);
 dlg.DoModal();
}
// [ionix] Avi3k: ServerFilter
//>>> Fenderman - Spooky Mode [eWombat] 
#ifdef SPOOKY 
void CServerWnd::OnSpookyconnect() 
{ 
if (!theApp.serverconnect->IsSpooky()) 
    theApp.serverconnect->ConnectSpooky(); 
else 
    theApp.serverconnect->DisconnectSpooky(); 
} 
#endif 
//<<< Fenderman - Spooky Mode [eWombat] 