// ZZ:UploadBandWithThrottler (UDP) -->

#pragma once

struct SocketSentBytes {
    bool    success;
	uint32	sentBytesStandardPackets;
	uint32	sentBytesControlPackets;
};

class ThrottledControlSocket
{
public:
	// Pawcio: BC
	ThrottledControlSocket() {onDownProcessQueue = false; onDownQueue = false; onDownControlQueue = false; onUpControlQueue = false; onBlockedQueue = false; onUpQueue = false;}
	virtual SocketSentBytes Send(uint32 maxNumberOfBytesToSend) = 0;
	virtual bool	IsConnected() const {return true;}
	virtual uint32	GetControlPacketFragSize(int minFragSize) = 0;
	virtual bool	IsBusy() const = 0;
	virtual bool	IsBufferFilled() const = 0;
	virtual bool	IsPrioritySend() {return false;}
	virtual bool	IsPriorityReceive() {return false;}
	virtual bool	isReadyToSendControlPacket() const = 0;
	virtual uint32	GetBlockedPacketFragSize(int minFragSize) = 0;
	virtual bool	CanBeRemovedFromControlQueue() const = 0;
	virtual bool	isUDP() const {return false;}
	bool onUpControlQueue;
	bool onBlockedQueue;
	bool onUpQueue;
	 // Pawcio: BC Download
	virtual int		Receive(uint32 size) = 0;
	virtual	void	ProcessData(bool ignore = false) = 0;
	bool onDownControlQueue;
	bool onDownProcessQueue;
	bool onDownQueue; 
	// <--- Pawcio: BC Download
	// <--- Pawcio: BC
};

class ThrottledFileSocket : public ThrottledControlSocket
{
public:
	//Pawcio: BC
    virtual DWORD GetLastCalledSend() = 0;
    virtual uint32	GetNeededBytes() = 0;
};

// <-- ZZ:UploadBandWithThrottler (UDP)
