//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#pragma once

#include "ThrottledSocket.h" // ZZ:UploadBandWithThrottler (UDP)
class CClientReqSocket; //Pawcio: BC

// Pawcio: BC
typedef struct {
	uint64	SentBytes;
	bool	bandwidthUsed;
	uint16	activeSlots;
} uploadValues;
// <--- Pawcio: BC

class UploadBandwidthThrottler :
    public CWinThread 
{
public:
    UploadBandwidthThrottler(void);
    ~UploadBandwidthThrottler(void);

    uploadValues GetNumberOfSentBytesSinceLastCallAndReset();
    // Pawcio: BC


    bool QueueForSendingControlPacket(ThrottledControlSocket* socket); // ZZ:UploadBandWithThrottler (UDP) // Pawcio: BC - changed
    void RemoveFromAllQueues(ThrottledControlSocket* socket) { RemoveFromAllQueues(socket, true); }; // ZZ:UploadBandWithThrottler (UDP)
    void RemoveFromAllQueues(ThrottledFileSocket* socket);

    void EndThread();

    // Pawcio: BC - removed

    void Pause(bool paused);

	// Pawcio: BC
	void AddToStandardList(CClientReqSocket* socket, bool toReserved = false);
	void AddToStandardListNoLock(CClientReqSocket* socket, bool toReserved = false);
    bool RemoveFromStandardList(CClientReqSocket* socket);

	bool AddToBlockedQueue(ThrottledControlSocket* socket);
	void DecreaseToSend(const int& bytes) {toSend -= bytes;}

	void MoveFromReserved();

	void ResetBC() {sendLocker.Lock(); feedingPos = NULL; reservedFeedingPos = NULL; sendLocker.Unlock();}
	void SetTimeUp(uint8 time) {timeUp = time;}
	void ReSortUploadSlots(CUpDownClient* client, bool toReserve);
	// <--- Pawcio: BC

private:
    static UINT RunProc(LPVOID pParam);
    UINT RunInternal();

    void RemoveFromAllQueues(ThrottledControlSocket* socket, bool lock); // ZZ:UploadBandWithThrottler (UDP)
	// Pawcio: BC
    bool RemoveFromStandardListNoLock(CClientReqSocket* socket);
	// <--- Pawcio: BC

    CTypedPtrList<CPtrList, ThrottledControlSocket*> m_ControlQueue_list; // a queue for all the sockets that want to have Send() called on them. // ZZ:UploadBandWithThrottler (UDP)

    //Pawcio: BC

    CCriticalSection sendLocker;
    CCriticalSection dataLocker;

    CEvent* threadEndedEvent;
    CEvent* pauseEvent;

    uint64 m_SentBytesSinceLastCall;

    uint32 m_allowedDataRate;

    bool doRun;

	// Pawcio: BC
	typedef struct TransferredData {
		uint32	datalen;
		DWORD	timestamp;
	};
    CTypedPtrList<CPtrList, CClientReqSocket*> uploadinglist;
    CTypedPtrList<CPtrList, CClientReqSocket*> reserveduploadinglist;
    CTypedPtrList<CPtrList, CClientReqSocket*> prioritylist;
    CTypedPtrList<CPtrList, ThrottledControlSocket*> blockedSockets;
	CList<TransferredData,TransferredData> sentToNormalList;
	CList<TransferredData,TransferredData> sentToReservedList;
	int     toSend;
	uint32	SentToNormal;
	uint32	SentToReserved;
	uint32	DataSentToNormal;
	uint32	DataSentToReserved;
	uint32	nextMinPacketSize;
	uint32	lastReOrder;
	bool	bandwidthUsed;
	POSITION feedingPos;
	POSITION reservedFeedingPos;
	CClientReqSocket* prioritySocket;
	uint8	timeUp;
	// <--- Pawcio: BC
};
